#! /usr/bin/env python

import sys, argparse

import moving, storage

from numpy import loadtxt

parser = argparse.ArgumentParser(description='The program computes the CLEAR MOT metrics between ground truth and tracker output (in Polytrack format)', epilog='''CLEAR MOT metrics information:
Keni, Bernardin, and Stiefelhagen Rainer. "Evaluating multiple object tracking performance: the CLEAR MOT metrics." EURASIP Journal on Image and Video Processing 2008 (2008)

Polytrack format: 
JP. Jodoin\'s MSc thesis (in french)
see examples on http://www.jpjodoin.com/urbantracker/dataset.html''', formatter_class=argparse.RawDescriptionHelpFormatter)
parser.add_argument('-d', dest = 'trackerDatabaseFilename', help = 'name of the Sqlite database containing the tracker output', required = True)
parser.add_argument('-g', dest = 'groundTruthDatabaseFilename', help = 'name of the Sqlite database containing the ground truth', required = True)
parser.add_argument('-o', dest = 'homographyFilename', help = 'name of the filename for the homography (if tracking was done using the homography)')
parser.add_argument('-m', dest = 'matchingDistance', help = 'matching distance between tracker and ground truth trajectories', required = True)
args = parser.parse_args()

# args.homographyFilename is None if nothing as argument
if args.homographyFilename != None:
    homography = loadtxt(args.homographyFilename)
else:
    homography = None

objects = storage.loadTrajectoriesFromSqlite(args.trackerDatabaseFilename, 'object')
annotations = storage.loadGroundTruthFromSqlite(args.groundTruthDatabaseFilename)
for a in annotations:
    a.computeCentroidTrajectory(homography)

moving.matchingGroundTruthToTracker(objects, annotations, args.matchingDistance)
#storage.deleteFromSqlite(args.databaseFilename, args.dataType)
